local hats_names = {"-","Baseball","Beret","Builder","Flat","Football","Garrison","Halo","Jason","Morocco","Pirate","Shemagh","Straw","Thief"}

local selected_hat = {}

local hats_open_hat_menu_key_text = "F2"

local hats_selected_hat_players = {}

local hats_temp_hat_menu_page_players = {}

function save_player_hat(id,selected_hat_name)
    local usgn = player(id, "usgn")
    local steamid = player(id, "steamid")
    local hat = selected_hat_name

    if not hat then return end  -- Ha nincs kalap kiválasztva, ne mentsen semmit

    local identifier
    if usgn and usgn ~= 0 then
        identifier = "usgn:" .. usgn
    elseif steamid and steamid ~= "0" then
        identifier = "steam:" .. steamid
    else
        return  -- Nincs érvényes azonosító
    end

    -- Meglévő fájl beolvasása
    local file_path = "sys/hats.cfg"
    local lines = {}
    local updated = false

    local f = io.open(file_path, "r")
    if f then
        for line in f:lines() do
            local id, old_hat = line:match("^(.-);(.-)$")
            if id == identifier then
                table.insert(lines, identifier .. ";" .. hat)
                updated = true
            else
                table.insert(lines, line)
            end
        end
        f:close()
    end

    if not updated then
        table.insert(lines, identifier .. ";" .. hat)
    end

    -- Írás vissza a fájlba
    f = io.open(file_path, "w")
    if f then
        for _, line in ipairs(lines) do
            f:write(line .. "\n")
        end
        f:close()
    end
end



---example for set custom hat on player id
---save_player_hat(1,"beret")



player_hat_image = {}

function get_hat_index_by_name(hatname)
    for i, name in ipairs(hats_names) do
        if name == hatname then
            return i
        end
    end
    return 1
end

function apply_hat_to_matching_players()
    -- Fájl megnyitása
    local f = io.open("sys/hats.cfg", "r")
    if not f then return end

    for line in f:lines() do
        local identifier, hatname = line:match("^(.-);(.-)$")
        if identifier and hatname then
            for id = 1, 32 do
                if player(id, "exists") then
                    local usgn = player(id, "usgn")
                    local steamid = player(id, "steamid")

                    local player_identifier = nil
                    if usgn and usgn ~= 0 then
                        player_identifier = "usgn:" .. usgn
                    elseif steamid and steamid ~= "0" then
                        player_identifier = "steam:" .. steamid
                    end

                    if player_identifier == identifier then
                        -- Kalap beállítása csak ha még nem lett beállítva
                        local imgpath = "gfx/hats_by_prefire/hats/" .. hatname .. ".png"
                        freeimage(id)
                        player_hat_image = image(imgpath, 10, 10, 200 + id)
                        hats_selected_hat_players[id] = get_hat_index_by_name(hatname)
                    end
                end
            end
        end
    end
    f:close()
end

addhook("always", "always_apply_hat")
function always_apply_hat()
    apply_hat_to_matching_players()
end

addhook("leave", "on_leave_remove_hat")

function on_leave_remove_hat(id)
    if player_hat_image[id] then
        freeimage(player_hat_image[id])
        player_hat_image[id] = nil
        hats_temp_hat_menu_page_players[id] = 1
        hats_selected_hat_players[id] = 1
    end
end





---Set Selected Hats Of Each Player To None---
for i = 1,91 do
    table.insert(hats_selected_hat_players,1)
end
for i = 1,91 do
    table.insert(hats_temp_hat_menu_page_players,1)
end

function HatsShowNoneHatText(id)
	if player(id,"language_iso") == "CZ" then
		return "Vypnout"
	elseif player(id,"language_iso") == "DE" then
		return "Abschalten"
	elseif player(id,"language_iso") == "ES" then
		return "Apagar"
	elseif player(id,"language_iso") == "FI" then
		return "Sammuttaa"
	elseif player(id,"language_iso") == "FR" then
		return "\201teindre"
	elseif player(id,"language_iso") == "ID" then
		return "Matikan"
	elseif player(id,"language_iso") == "IT" then
		return "Spegnere"
	elseif player(id,"language_iso") == "NL" then
		return "Uitschakelen"
	elseif player(id,"language_iso") == "PL" then
		return "Wylaczyc cos"
	elseif player(id,"language_iso") == "PT" then
		return "Desligar"
	elseif player(id,"language_iso") == "RO" then
		return "Opriti"
	elseif player(id,"language_iso") == "RS" then
		return "Isklju\231iti"
	elseif player(id,"language_iso") == "SV" then
		return "St\228ng Av"
	elseif player(id,"language_iso") == "TR" then
		return "Kapamak"
	elseif player(id,"language_iso") == "HU" then
		return "Kikapcsol"
	elseif player(id,"language_iso") == "XX" then
		return "7urn 0FF"
	else
		return "Turn OFF"
	end
end

function HatsShowSelectHatTitleText(id)
	if player(id,"language_iso") == "CZ" then
		return "Vybrat Klobouk"
	elseif player(id,"language_iso") == "DE" then
		return "Hut Ausw\228hlen"
	elseif player(id,"language_iso") == "ES" then
		return "Seleccionar Sombrero"
	elseif player(id,"language_iso") == "FI" then
		return "Valitse Hattu"
	elseif player(id,"language_iso") == "FR" then
		return "S\233lectionner Un Chapeau"
	elseif player(id,"language_iso") == "ID" then
		return "Pilih Topi"
	elseif player(id,"language_iso") == "IT" then
		return "Seleziona Il Cappello"
	elseif player(id,"language_iso") == "NL" then
		return "Selecteer Hoed"
	elseif player(id,"language_iso") == "PL" then
		return "Wybierz Kapelusz"
	elseif player(id,"language_iso") == "PT" then
		return "Selecione Chap\233u"
	elseif player(id,"language_iso") == "RO" then
		return "Alege Palarie"
	elseif player(id,"language_iso") == "RS" then
		return "Odaberite \138e\154ir"
	elseif player(id,"language_iso") == "SV" then
		return "V\228lj Hatt"
	elseif player(id,"language_iso") == "TR" then
		return "Sapka Sec"
	elseif player(id,"language_iso") == "HU" then
		return "V\225lassz Kalapot"
	elseif player(id,"language_iso") == "XX" then
		return "53l3c7 H47"
	else
		return "Select Hat"
	end
end

function HatsCheckPlayerCurrentHatIsThis(id,hat_id)
    if hats_selected_hat_players[id] == hat_id then
        return "[X]"
    else
        return ""
    end
end

function HatsCheckThisHatIsExists(hat_id)
    if #hats_names >= hat_id then
        return hats_names[hat_id]
    else
        return "("
    end
end

function hats_open_hat_menu_page_1(id)
	menu(id,""..HatsShowSelectHatTitleText(id)..","..HatsShowNoneHatText(id).." | "..HatsCheckPlayerCurrentHatIsThis(id,1)..","..HatsCheckThisHatIsExists(2).." | "..HatsCheckPlayerCurrentHatIsThis(id,2)..","..HatsCheckThisHatIsExists(3).." | "..HatsCheckPlayerCurrentHatIsThis(id,3)..","..HatsCheckThisHatIsExists(4).." | "..HatsCheckPlayerCurrentHatIsThis(id,4)..","..HatsCheckThisHatIsExists(5).." | "..HatsCheckPlayerCurrentHatIsThis(id,5)..","..HatsCheckThisHatIsExists(6).." | "..HatsCheckPlayerCurrentHatIsThis(id,6)..","..HatsCheckThisHatIsExists(7).." | "..HatsCheckPlayerCurrentHatIsThis(id,7)..",(<),>")
end

function hats_open_hat_menu_page_2(id)
	menu(id,""..HatsShowSelectHatTitleText(id).." ,"..HatsShowNoneHatText(id).." | "..HatsCheckPlayerCurrentHatIsThis(id,1)..","..HatsCheckThisHatIsExists(8).." | "..HatsCheckPlayerCurrentHatIsThis(id,8)..","..HatsCheckThisHatIsExists(9).." | "..HatsCheckPlayerCurrentHatIsThis(id,9)..","..HatsCheckThisHatIsExists(10).." | "..HatsCheckPlayerCurrentHatIsThis(id,10)..","..HatsCheckThisHatIsExists(11).." | "..HatsCheckPlayerCurrentHatIsThis(id,11)..","..HatsCheckThisHatIsExists(12).." | "..HatsCheckPlayerCurrentHatIsThis(id,12)..","..HatsCheckThisHatIsExists(13).." | "..HatsCheckPlayerCurrentHatIsThis(id,13)..",<,>")
end

function hats_open_hat_menu_page_3(id)
	menu(id,""..HatsShowSelectHatTitleText(id).."  ,"..HatsShowNoneHatText(id).." | "..HatsCheckPlayerCurrentHatIsThis(id,1)..","..HatsCheckThisHatIsExists(14).." | "..HatsCheckPlayerCurrentHatIsThis(id,14)..","..HatsCheckThisHatIsExists(15).." | "..HatsCheckPlayerCurrentHatIsThis(id,15)..","..HatsCheckThisHatIsExists(16).." | "..HatsCheckPlayerCurrentHatIsThis(id,16)..","..HatsCheckThisHatIsExists(17).." | "..HatsCheckPlayerCurrentHatIsThis(id,17)..","..HatsCheckThisHatIsExists(18).." | "..HatsCheckPlayerCurrentHatIsThis(id,18)..","..HatsCheckThisHatIsExists(19).." | "..HatsCheckPlayerCurrentHatIsThis(id,19)..",<,(>)")
end

addhook("menu" , "hats_hat_menu_interaction_page_1")
function hats_hat_menu_interaction_page_1(id, title, button)
	if (title == ""..HatsShowSelectHatTitleText(id).."") then
		if button == 1 then
			save_player_hat(id,hats_names[1])
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 2 then
			save_player_hat(id,hats_names[2])
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 3 then
			save_player_hat(id,hats_names[3])
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 4 then
			save_player_hat(id,hats_names[4])
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 5 then
			save_player_hat(id,hats_names[5])
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 6 then
			save_player_hat(id,hats_names[6])
			hats_temp_hat_menu_page_players[id] = 1
        elseif button == 7 then
			save_player_hat(id,hats_names[7])
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 8 then
			hats_open_hat_menu_page_1(id)
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 9 then
			hats_open_hat_menu_page_2(id)
			hats_temp_hat_menu_page_players[id] = 2
		end
	end
end

addhook("menu" , "hats_hat_menu_interaction_page_2")
function hats_hat_menu_interaction_page_2(id, title, button)
	if (title == ""..HatsShowSelectHatTitleText(id).." ") then
		if button == 1 then
			save_player_hat(id,hats_names[1])
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 2 then
			save_player_hat(id,hats_names[8])
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 3 then
			save_player_hat(id,hats_names[9])
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 4 then
			save_player_hat(id,hats_names[10])
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 5 then
			save_player_hat(id,hats_names[11])
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 6 then
			save_player_hat(id,hats_names[12])
			hats_temp_hat_menu_page_players[id] = 2
        elseif button == 7 then
			save_player_hat(id,hats_names[13])
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 8 then
			hats_open_hat_menu_page_1(id)
			hats_temp_hat_menu_page_players[id] = 1
		elseif button == 9 then
			hats_open_hat_menu_page_3(id)
			hats_temp_hat_menu_page_players[id] = 3
		end
	end
end

addhook("menu" , "hats_hat_menu_interaction_page_3")
function hats_hat_menu_interaction_page_3(id, title, button)
	if (title == ""..HatsShowSelectHatTitleText(id).."  ") then
		if button == 1 then
			save_player_hat(id,hats_names[1])
			hats_temp_hat_menu_page_players[id] = 3
		elseif button == 2 then
			save_player_hat(id,hats_names[14])
			hats_temp_hat_menu_page_players[id] = 3
		elseif button == 3 then
			save_player_hat(id,hats_names[15])
			hats_temp_hat_menu_page_players[id] = 3
		elseif button == 4 then
			save_player_hat(id,hats_names[16])
			hats_temp_hat_menu_page_players[id] = 3
		elseif button == 5 then
			save_player_hat(id,hats_names[17])
			hats_temp_hat_menu_page_players[id] = 3
		elseif button == 6 then
			save_player_hat(id,hats_names[18])
			hats_temp_hat_menu_page_players[id] = 3
        elseif button == 7 then
			save_player_hat(id,hats_names[19])
			hats_temp_hat_menu_page_players[id] = 3
		elseif button == 8 then
			hats_open_hat_menu_page_2(id)
			hats_temp_hat_menu_page_players[id] = 2
		elseif button == 9 then
			hats_open_hat_menu_page_3(id)
			hats_temp_hat_menu_page_players[id] = 3
		end
	end
end

addhook("serveraction","hats_serveraction")
function hats_serveraction(id,action)
    if action == 1 then
		if hats_temp_hat_menu_page_players[id] == 1 then
			hats_open_hat_menu_page_1(id)
		elseif hats_temp_hat_menu_page_players[id] == 2 then
			hats_open_hat_menu_page_2(id)
        elseif hats_temp_hat_menu_page_players[id] == 3 then
			hats_open_hat_menu_page_3(id)
		end
    end
end



---Do Empty Servertransfer.lst---
local hats_test_file = io.open("sys/servertransfer.lst", "w")
hats_test_file:write("")
hats_test_file:close()
---Write servertransfer.lst to send the resources to players---
timer(1250,"hats_send_resources")
function hats_send_resources()
	local hats_file = io.open("sys/servertransfer.lst", "a")

	if hats_file then
		
		local handle = io.popen("dir gfx\\hats_by_prefire\\hats\\ /b")
		for hats_filename in handle:lines() do
			hats_file:write("gfx/hats_by_prefire/hats/" .. hats_filename .. "\n")
		end
		handle:close()
		hats_file:close()
	else
		print("Server Transfer - Image Not Found Error!")
	end
end






function HatsShowSelectHatMenuKeyText(id)
	if player(id,"language_iso") == "CZ" then
		return "Stisknutim ["..hats_open_hat_menu_key_text.."] vyberte klobouk"
	elseif player(id,"language_iso") == "DE" then
		return "Dr\252cken Sie ["..hats_open_hat_menu_key_text.."], um Hut auszuw\228hlen"
	elseif player(id,"language_iso") == "ES" then
		return "Presione ["..hats_open_hat_menu_key_text.."] para seleccionar el sombrero"
	elseif player(id,"language_iso") == "FI" then
		return "Paina ["..hats_open_hat_menu_key_text.."] valitaksesi hattu"
	elseif player(id,"language_iso") == "FR" then
		return "Appuyez sur ["..hats_open_hat_menu_key_text.."] pour s\233lectionner le chapeau"
	elseif player(id,"language_iso") == "ID" then
		return "Tekan ["..hats_open_hat_menu_key_text.."] untuk memilih topi"
	elseif player(id,"language_iso") == "IT" then
		return "Premi ["..hats_open_hat_menu_key_text.."] per selezionare il cappello"
	elseif player(id,"language_iso") == "NL" then
		return "Druk op ["..hats_open_hat_menu_key_text.."] om hoed te selecteren"
	elseif player(id,"language_iso") == "PL" then
		return "Nacisnij ["..hats_open_hat_menu_key_text.."], aby wybrac kapelusz"
	elseif player(id,"language_iso") == "PT" then
		return "Pressione ["..hats_open_hat_menu_key_text.."] para selecionar o chap\233u"
	elseif player(id,"language_iso") == "RO" then
		return "Apasati ["..hats_open_hat_menu_key_text.."] pentru a selecta palarie"
	elseif player(id,"language_iso") == "RS" then
		return "Pritisnite ["..hats_open_hat_menu_key_text.."] za odabir \154e\154ira"
	elseif player(id,"language_iso") == "SV" then
		return "Tryck p\229 ["..hats_open_hat_menu_key_text.."] f\246r att v\228lja hatt"
	elseif player(id,"language_iso") == "TR" then
		return "Sapkayi secmek icin ["..hats_open_hat_menu_key_text.."] tusuna basin"
	elseif player(id,"language_iso") == "HU" then
		return "Nyomd meg az ["..hats_open_hat_menu_key_text.."] gombot a kalap kiv\225laszt\225s\225hoz"
	elseif player(id,"language_iso") == "XX" then
		return "Pr355 ["..hats_open_hat_menu_key_text.."] 70 53l3c7 h47"
	else
		return "Press ["..hats_open_hat_menu_key_text.."] to select hat"
	end
end


addhook("startround","hats_start_round")
function hats_start_round()
	hats_all_living_players = player(0,"tableliving")
	for i = 1,#hats_all_living_players do
		msg2(hats_all_living_players[i], ""..HatsShowSelectHatMenuKeyText(hats_all_living_players[i]).."")
	end
end
hats_start_round()